require 'dldinternet/thor/command'
require 'dldinternet/opensrs/domain/command'
require 'dldinternet/opensrs/nameservers/command'

module DLDInternet
  module OpenSRS
    class Main < DLDInternet::Thor::Command
      class_option :verbose,      type: :boolean
      class_option :debug,        type: :boolean
      class_option :trace,        type: :boolean
      class_option :log_level,    type: :string, banner: 'Log level ([:trace, :debug, :info, :step, :warn, :error, :fatal, :todo])'
      class_option :server,       type: :string, default: "https://rr-n1-tor.opensrs.net:55443"
      class_option :username,     type: :string, default: 'dldinternet'
      class_option :password,     type: :string
      class_option :key,          type: :string
      class_option :inifile,      type: :string, default: '~/.opensrs.ini'
      class_option :format,       type: :string, default: :none, aliases: [ '--output']

      desc 'domain SUBCOMMAND ... ARGS', 'do domains'
      subcommand 'domain', ::DLDInternet::OpenSRS::Domain::Command

      desc 'nameservers SUBCOMMAND ... ARGS', 'do domains'
      subcommand 'nameservers', ::DLDInternet::OpenSRS::NameServers::Command
    end
  end
end